import com.j256.ormlite.dao.*;
import com.j256.ormlite.stmt.PreparedQuery;
import com.j256.ormlite.stmt.QueryBuilder;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class AccountService{

    private final Dao<Account, Integer> dao;

    public AccountService(Dao<Account, Integer> dao){
        this.dao = dao;
    }

    public int create(Account account){
        try {
            return dao.create(account);
        }catch(Exception e){

        }
        return -1;
    }

    public List<Account> querey(String input, String column){
        List<Account> accountList = new ArrayList<>();
        try {
            QueryBuilder<Account, Integer> qb = dao.queryBuilder();
            qb
                    .where()
                    .eq(column, input);
            PreparedQuery<Account> preparedQuery = qb.prepare();
            accountList = dao.query(preparedQuery);
        }catch(Exception e){
            e.printStackTrace();
        }

        return accountList;
    }

    public List<Account> multipleCaseQuery(String input1, String input2, String column1, String column2){
        List<Account> accountList = new ArrayList<>();
        try {
            QueryBuilder<Account, Integer> qb = dao.queryBuilder();
            qb
                    .where()
                    .eq(column1, input1)
                    .and().eq(column2, input2);
            PreparedQuery<Account> preparedQuery = qb.prepare();
            accountList = dao.query(preparedQuery);
        } catch(Exception e){
            e.printStackTrace();
        }

        return accountList;
    }

    public int changePassword(Account account, String password){
        account.setPassword(password);
        try {
            return dao.update(account);
        } catch (SQLException e){
            e.printStackTrace();
        }
        return -1;
    }


    public int changeUsername(Account account, String user){
        account.setName(user);
        try {
            return dao.update(account);
        } catch (SQLException e){
            e.printStackTrace();
        }
        return -1;
    }

    public int deleteAccount(Account account){
        try {
            return dao.delete(account);
        } catch(SQLException e){
            e.printStackTrace();
        }
        return -1;
    }

    public boolean verifyPassword(Account account, String password){
        List<Account> results = multipleCaseQuery(account.getName(), password, Account.NAME_FIELD_NAME, Account.PASSWORD_FIELD_NAME);
        Account queryResult = null;
        if(results.size() == 1){
            queryResult = results.get(0);
        } else {
            Console.println("Sorry, the password is incorrect.");
        }
        if(account.equals(queryResult)){
            return true;
        } else {
            return false;
        }
    }
}
